<template>
  <aside
    class="ui-call-out flex gap-2 rounded-md border-l-4 p-2 [--tw-prose-bullets:rgb(var(--base-rgb)/75%)] [--tw-prose-counters:rgb(var(--base-rgb)/75%)] [--tw-prose-hr:rgb(var(--base-rgb)/50%)] [--tw-prose-quote-borders:rgb(var(--base-rgb)/50%)] [--tw-prose-td-borders:rgb(var(--base-rgb)/25%)] [--tw-prose-th-borders:rgb(var(--base-rgb)/50%)] md:gap-4 md:p-4"
    :class="{
      'border-violet-500 bg-violet-50 text-violet-900 [--base-rgb:109_40_217]':
        !info && !success && !warning && !danger && !black && !gray,
      'border-blue-500 bg-blue-50 text-blue-900 [--base-rgb:3_105_161]': info,
      'border-green-500 bg-green-50 text-green-900 [--base-rgb:4_120_87]':
        success,
      'border-yellow-400 bg-yellow-100 text-yellow-900 [--base-rgb:120_53_15]':
        warning,
      'border-red-500 bg-red-50 text-red-900 [--base-rgb:159_18_57]': danger,
      'border-black bg-gray-100 text-black [--base-rgb:23_23_23]': black,
      'border-gray-400 bg-gray-100 text-gray-600 [--base-rgb:82_82_82]': gray,
    }"
  >
    <div v-if="!noIcon && icon?.trim()" role="presentation" aria-hidden="true">
      <slot name="icon">
        <span class="md:text-2xl lg:text-2xl xl:text-3xl">{{ icon }}</span>
      </slot>
    </div>
    <div
      class="[&_:first-child]:mt-0 [&_:last-child]:mb-0 [&_:not(:where([class*='ui-'],.not-prose))]:text-current"
    >
      <slot />
    </div>
  </aside>
</template>

<script lang="ts" setup>
defineOptions({
  name: 'UiCallOut',
})

defineProps({
  icon: {
    type: String,
    default: '📌',
  },
  noIcon: {
    type: Boolean,
    default: false,
  },
  info: {
    type: Boolean,
    default: false,
  },
  success: {
    type: Boolean,
    default: false,
  },
  warning: {
    type: Boolean,
    default: false,
  },
  danger: {
    type: Boolean,
    default: false,
  },
  black: {
    type: Boolean,
    default: false,
  },
  gray: {
    type: Boolean,
    default: false,
  },
})
</script>
